﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using WebApplication3.Models;

namespace WebApplication3.Clases
{
    public class ZoneData
    {
        public uint Id { get; set; }
        public string Storage { get; set; }
        public string ConstantHead { get; set; }
        public string Drains { get; set; }
        public string Wells { get; set; }
        public string Recharge { get; set; }
        public string Total { get; set; }

        public List<ZoneConnection> ZoneConnections { get; set; }

        public ZoneData()
        {
            ZoneConnections = new List<ZoneConnection>();
        }

        public ZoneData(List<ZoneConnection> connections)
        {
            ZoneConnections = connections;
        }

        public ZoneData(DatosBalanceIn dataIn)
        {
            Id = dataIn.Id;
            Storage = dataIn.Storage;
            ConstantHead = dataIn.ConstantHead;
            Drains = dataIn.Drains;
            Wells = dataIn.Wells;
            Recharge = dataIn.Recharge;
            Total = dataIn.Total;
            ZoneConnections = new List<ZoneConnection>();
        }

        public ZoneData(DatosBalanceOut dataOut)
        {
            Id = dataOut.Id;
            Storage = dataOut.Storage;
            ConstantHead = dataOut.ConstantHead;
            Drains = dataOut.Drains;
            Wells = dataOut.Wells;
            Recharge = dataOut.Recharge;
            Total = dataOut.Total;
            ZoneConnections = new List<ZoneConnection>();
        }

        public DatosBalanceIn ToDatosBalanceIn(uint? idBalance)
        {
            DatosBalanceIn datosIn = new DatosBalanceIn();
            datosIn.Storage = this.Storage;
            datosIn.ConstantHead = this.ConstantHead;
            datosIn.Drains = this.Drains;
            datosIn.Wells = this.Wells;
            datosIn.Recharge = this.Recharge;
            datosIn.Total = this.Total;
            datosIn.IdBalance = idBalance;

            return datosIn;
        }

        public DatosBalanceOut ToDatosBalanceOut(uint? idBalance)
        {
            DatosBalanceOut datosOut = new DatosBalanceOut();
            datosOut.Storage = this.Storage;
            datosOut.ConstantHead = this.ConstantHead;
            datosOut.Drains = this.Drains;
            datosOut.Wells = this.Wells;
            datosOut.Recharge = this.Recharge;
            datosOut.Total = this.Total;
            datosOut.IdBalance = idBalance;

            return datosOut;
        }

    }
}
