using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using WebApplication3.Clases;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApplication3
{
    public class Program
    {
        public static void Main( string[] args )
        {
            Proceso proceso = Proceso.GetInstance();
            CreateHostBuilder( args ).Build().Run();
        }

        public static IHostBuilder CreateHostBuilder( string[] args ) =>
            Host.CreateDefaultBuilder( args )
                .ConfigureLogging(logging =>
                {
                    logging.ClearProviders();
                    logging.AddConsole();
                    logging.AddEventLog();
                })
                .ConfigureServices((hostBuilderContext, services) =>
                {
                    services.AddLogging();
                    services.AddHostedService<Worker>();
                    services.AddHostedService<QueueWorker>();

                })
                .ConfigureWebHostDefaults( webBuilder =>
                {
                    webBuilder.UseStartup<Startup>();
                    webBuilder.UseHttpSys(options =>
                    {
                        options.MaxRequestBodySize = 300_000_000;
                    });

                } ).ConfigureWebHost( config =>
                {
                    config.UseUrls( "http://*:5050" );


                } ).UseWindowsService();

    }
}
